package org.warp.commonutils.concurrency.executor;

import java.util.Objects;
import java.util.concurrent.Callable;

public abstract class CallableDecorator<T> implements Callable<T> {

	private final Callable<T> callable;

	public CallableDecorator(Callable<T> callable) {
		this.callable = Objects.requireNonNull(callable);
	}

	@Override
	public T call() throws Exception {
		return callable.call();
	}
}
