package org.warp.commonutils.concurrency.executor;

import java.util.Objects;

public abstract class RunnableDecorator implements Runnable {

	private final Runnable runnable;

	public RunnableDecorator(Runnable runnable) {
		this.runnable = Objects.requireNonNull(runnable);
	}

	@Override
	public void run() {
		runnable.run();
	}
}
