package org.warp.commonutils.log;

import org.slf4j.Marker;

public class Logger implements org.slf4j.Logger {

	private final org.slf4j.Logger loggerDelegate;

	public Logger(org.slf4j.Logger logger) {
		this.loggerDelegate = logger;
	}

	@Override
	public String getName() {
		return loggerDelegate.getName();
	}

	@Override
	public boolean isTraceEnabled() {
		return Logs.isTraceEnabled() && loggerDelegate.isTraceEnabled();
	}

	@Override
	public void trace(String s) {
		if (Logs.isTraceEnabled()) {
			loggerDelegate.trace(s);
		}
	}

	@Override
	public void trace(String s, Object o) {
		if (Logs.isTraceEnabled()) {
			loggerDelegate.trace(s, o);
		}
	}

	@Override
	public void trace(String s, Object o, Object o1) {
		if (Logs.isTraceEnabled()) {
			loggerDelegate.trace(s, o, o1);
		}
	}

	@Override
	public void trace(String s, Object... objects) {
		if (Logs.isTraceEnabled()) {
			loggerDelegate.trace(s, objects);
		}
	}

	@Override
	public void trace(String s, Throwable throwable) {
		if (Logs.isTraceEnabled()) {
			loggerDelegate.trace(s, throwable);
		}
	}

	@Override
	public boolean isTraceEnabled(Marker marker) {
		return Logs.isTraceEnabled() && loggerDelegate.isTraceEnabled(marker);
	}

	@Override
	public void trace(Marker marker, String s) {
		if (Logs.isTraceEnabled()) {
			loggerDelegate.trace(marker, s);
		}
	}

	@Override
	public void trace(Marker marker, String s, Object o) {
		if (Logs.isTraceEnabled()) {
			loggerDelegate.trace(marker, s, o);
		}
	}

	@Override
	public void trace(Marker marker, String s, Object o, Object o1) {
		if (Logs.isTraceEnabled()) {
			loggerDelegate.trace(marker, s, o, o1);
		}
	}

	@Override
	public void trace(Marker marker, String s, Object... objects) {
		if (Logs.isTraceEnabled()) {
			loggerDelegate.trace(marker, s, objects);
		}
	}

	@Override
	public void trace(Marker marker, String s, Throwable throwable) {
		if (Logs.isTraceEnabled()) {
			loggerDelegate.trace(marker, s, throwable);
		}
	}

	@Override
	public boolean isDebugEnabled() {
		return Logs.isDebugEnabled() && loggerDelegate.isDebugEnabled();
	}

	@Override
	public void debug(String s) {
		if (Logs.isDebugEnabled()) {
			loggerDelegate.debug(s);
		}
	}

	@Override
	public void debug(String s, Object o) {
		if (Logs.isDebugEnabled()) {
			loggerDelegate.debug(s, o);
		}
	}

	@Override
	public void debug(String s, Object o, Object o1) {
		if (Logs.isDebugEnabled()) {
			loggerDelegate.debug(s, o, o1);
		}
	}

	@Override
	public void debug(String s, Object... objects) {
		if (Logs.isDebugEnabled()) {
			loggerDelegate.debug(s, objects);
		}
	}

	@Override
	public void debug(String s, Throwable throwable) {
		if (Logs.isDebugEnabled()) {
			loggerDelegate.debug(s, throwable);
		}
	}

	@Override
	public boolean isDebugEnabled(Marker marker) {
		return Logs.isDebugEnabled() && loggerDelegate.isDebugEnabled(marker);
	}

	@Override
	public void debug(Marker marker, String s) {
		if (Logs.isDebugEnabled()) {
			loggerDelegate.debug(marker, s);
		}
	}

	@Override
	public void debug(Marker marker, String s, Object o) {
		if (Logs.isDebugEnabled()) {
			loggerDelegate.debug(marker, s, o);
		}
	}

	@Override
	public void debug(Marker marker, String s, Object o, Object o1) {
		if (Logs.isDebugEnabled()) {
			loggerDelegate.debug(marker, s, o, o1);
		}
	}

	@Override
	public void debug(Marker marker, String s, Object... objects) {
		if (Logs.isDebugEnabled()) {
			loggerDelegate.debug(marker, s, objects);
		}
	}

	@Override
	public void debug(Marker marker, String s, Throwable throwable) {
		if (Logs.isDebugEnabled()) {
			loggerDelegate.debug(marker, s, throwable);
		}
	}

	@Override
	public boolean isInfoEnabled() {
		return Logs.isInfoEnabled() && loggerDelegate.isInfoEnabled();
	}

	@Override
	public void info(String s) {
		if (Logs.isInfoEnabled()) {
			loggerDelegate.info(s);
		}
	}

	@Override
	public void info(String s, Object o) {
		if (Logs.isInfoEnabled()) {
			loggerDelegate.info(s, o);
		}
	}

	@Override
	public void info(String s, Object o, Object o1) {
		if (Logs.isInfoEnabled()) {
			loggerDelegate.info(s, o, o1);
		}
	}

	@Override
	public void info(String s, Object... objects) {
		if (Logs.isInfoEnabled()) {
			loggerDelegate.info(s, objects);
		}
	}

	@Override
	public void info(String s, Throwable throwable) {
		if (Logs.isInfoEnabled()) {
			loggerDelegate.info(s, throwable);
		}
	}

	@Override
	public boolean isInfoEnabled(Marker marker) {
		return Logs.isInfoEnabled() && loggerDelegate.isInfoEnabled(marker);
	}

	@Override
	public void info(Marker marker, String s) {
		if (Logs.isInfoEnabled()) {
			loggerDelegate.info(marker, s);
		}
	}

	@Override
	public void info(Marker marker, String s, Object o) {
		if (Logs.isInfoEnabled()) {
			loggerDelegate.info(marker, s, o);
		}
	}

	@Override
	public void info(Marker marker, String s, Object o, Object o1) {
		if (Logs.isInfoEnabled()) {
			loggerDelegate.info(marker, s, o, o1);
		}
	}

	@Override
	public void info(Marker marker, String s, Object... objects) {
		if (Logs.isInfoEnabled()) {
			loggerDelegate.info(marker, s, objects);
		}
	}

	@Override
	public void info(Marker marker, String s, Throwable throwable) {
		if (Logs.isInfoEnabled()) {
			loggerDelegate.info(marker, s, throwable);
		}
	}

	@Override
	public boolean isWarnEnabled() {
		return Logs.isWarnEnabled() && loggerDelegate.isWarnEnabled();
	}

	@Override
	public void warn(String s) {
		if (Logs.isWarnEnabled()) {
			loggerDelegate.warn(s);
		}
	}

	@Override
	public void warn(String s, Object o) {
		if (Logs.isWarnEnabled()) {
			loggerDelegate.warn(s, o);
		}
	}

	@Override
	public void warn(String s, Object... objects) {
		if (Logs.isWarnEnabled()) {
			loggerDelegate.warn(s, objects);
		}
	}

	@Override
	public void warn(String s, Object o, Object o1) {
		if (Logs.isWarnEnabled()) {
			loggerDelegate.warn(s, o, o1);
		}
	}

	@Override
	public void warn(String s, Throwable throwable) {
		if (Logs.isWarnEnabled()) {
			loggerDelegate.warn(s, throwable);
		}
	}

	@Override
	public boolean isWarnEnabled(Marker marker) {
		return Logs.isWarnEnabled() && loggerDelegate.isWarnEnabled(marker);
	}

	@Override
	public void warn(Marker marker, String s) {
		if (Logs.isWarnEnabled()) {
			loggerDelegate.warn(marker, s);
		}
	}

	@Override
	public void warn(Marker marker, String s, Object o) {
		if (Logs.isWarnEnabled()) {
			loggerDelegate.warn(marker, s, o);
		}
	}

	@Override
	public void warn(Marker marker, String s, Object o, Object o1) {
		if (Logs.isWarnEnabled()) {
			loggerDelegate.warn(marker, s, o, o1);
		}
	}

	@Override
	public void warn(Marker marker, String s, Object... objects) {
		if (Logs.isWarnEnabled()) {
			loggerDelegate.warn(marker, s, objects);
		}
	}

	@Override
	public void warn(Marker marker, String s, Throwable throwable) {
		if (Logs.isWarnEnabled()) {
			loggerDelegate.warn(marker, s, throwable);
		}
	}

	@Override
	public boolean isErrorEnabled() {
		return Logs.isErrorEnabled() && loggerDelegate.isErrorEnabled();
	}

	@Override
	public void error(String s) {
		if (Logs.isErrorEnabled()) {
			loggerDelegate.error(s);
		}
	}

	@Override
	public void error(String s, Object o) {
		if (Logs.isErrorEnabled()) {
			loggerDelegate.error(s, o);
		}
	}

	@Override
	public void error(String s, Object o, Object o1) {
		if (Logs.isErrorEnabled()) {
			loggerDelegate.error(s, o, o1);
		}
	}

	@Override
	public void error(String s, Object... objects) {
		if (Logs.isErrorEnabled()) {
			loggerDelegate.error(s, objects);
		}
	}

	@Override
	public void error(String s, Throwable throwable) {
		if (Logs.isErrorEnabled()) {
			loggerDelegate.error(s, throwable);
		}
	}

	@Override
	public boolean isErrorEnabled(Marker marker) {
		return Logs.isErrorEnabled() && loggerDelegate.isErrorEnabled(marker);
	}

	@Override
	public void error(Marker marker, String s) {
		if (Logs.isErrorEnabled()) {
			loggerDelegate.error(marker, s);
		}
	}

	@Override
	public void error(Marker marker, String s, Object o) {
		if (Logs.isErrorEnabled()) {
			loggerDelegate.error(marker, s, o);
		}
	}

	@Override
	public void error(Marker marker, String s, Object o, Object o1) {
		if (Logs.isErrorEnabled()) {
			loggerDelegate.error(marker, s, o, o1);
		}
	}

	@Override
	public void error(Marker marker, String s, Object... objects) {
		if (Logs.isErrorEnabled()) {
			loggerDelegate.error(marker, s, objects);
		}
	}

	@Override
	public void error(Marker marker, String s, Throwable throwable) {
		if (Logs.isErrorEnabled()) {
			loggerDelegate.error(marker, s, throwable);
		}
	}
}
