package org.warp.commonutils.log;

public class Logs {

	private static boolean traceEnabled;
	private static boolean debugEnabled;
	private static boolean infoEnabled;
	private static boolean warnEnabled;
	private static Level rootLevel;

	public static void setRootLevel(Level level) {
		rootLevel = level;
		switch (level) {
			case ERROR:
				traceEnabled = false;
				debugEnabled = false;
				infoEnabled = false;
				warnEnabled = false;
				break;
			case WARN:
				traceEnabled = false;
				debugEnabled = false;
				infoEnabled = false;
				warnEnabled = true;
				break;
			case INFO:
				traceEnabled = false;
				debugEnabled = false;
				infoEnabled = true;
				warnEnabled = true;
				break;
			case DEBUG:
				traceEnabled = false;
				debugEnabled = true;
				infoEnabled = true;
				warnEnabled = true;
				break;
			case TRACE:
				traceEnabled = true;
				debugEnabled = true;
				infoEnabled = true;
				warnEnabled = true;
				break;
		}
	}

	public static Level getRootLevel() {
		return rootLevel;
	}

	public static boolean isTraceEnabled() {
		return traceEnabled;
	}

	public static boolean isDebugEnabled() {
		return debugEnabled;
	}

	public static boolean isInfoEnabled() {
		return infoEnabled;
	}

	public static boolean isWarnEnabled() {
		return warnEnabled;
	}

	public static boolean isErrorEnabled() {
		return true;
	}
}
