package org.warp.commonutils.type;

import java.util.Objects;

public class EqualsWrapper<T> {

	private final T value;
	private final Object equal;

	public EqualsWrapper(T value, Object equal) {
		this.value = value;
		this.equal = equal;
	}

	public T get() {
		return value;
	}

	@Override
	public boolean equals(Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		EqualsWrapper<?> that = (EqualsWrapper<?>) o;
		return Objects.equals(equal, that.equal);
	}

	@Override
	public int hashCode() {
		return Objects.hash(equal);
	}
}
